/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH SOFTWARE CODEC SOURCE CODE.   *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS GOVERNED BY *
 * THE GNU PUBLIC LICENSE 2, WHICH ARE INCLUDED WITH THIS SOURCE.   *
 * PLEASE READ THESE TERMS DISTRIBUTING.                            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1998             *
 * 1998 Monty and The XIPHOPHORUS Company                           *
 * http://www.xiph.com/                                             *
 *                                                                  *
 ********************************************************************

  file: ppqmf.c
  function: polyphase pseudo-quadrature mirror filterbank toplevel
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty
  last modification date: Nov 8 1998

 ********************************************************************/

#include <stdlib.h>
#include <string.h>
#include "ppqmf.h"

void clear_subbander(ppQMF_subbander *p){
  if(p){
    long i;

    /* Not actually portable to memset this */
    for(i=0;i<p->windowsize+p->bands;i++)
      p->work[i]=0;

  }
}

ppQMF_subbander *init_subbander(int bands, int windowmult){
  ppQMF_subbander *ret=calloc(1,sizeof(ppQMF_subbander));

  ret->windowsize=bands*windowmult;
  ret->windowmult=windowmult;
  ret->bands=bands;

  ret->work=malloc((ret->windowsize+ret->bands)*sizeof(float));
  ret->buffer=ret->work+ret->bands;

  clear_subbander(ret);
  return(ret);
}

void input_subbander(ppQMF_subbander *p,float *newvals){
  float *base=p->buffer;
  memmove(base,base+p->bands,sizeof(float)*(p->windowsize-p->bands));
  memcpy(base+p->windowsize-p->bands,newvals,sizeof(float)*p->bands);
}

void output_subbander(ppQMF_subbander *p,float *newvals){
  float *base=p->buffer;
  memcpy(newvals,base,sizeof(float)*p->bands);
  memmove(base,base+p->bands,sizeof(float)*(p->windowsize-p->bands));
  memset(base+p->windowsize-p->bands,0,sizeof(float)*p->bands);
}




