/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH SOFTWARE CODEC SOURCE CODE.   *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS GOVERNED BY *
 * THE GNU PUBLIC LICENSE 2, WHICH ARE INCLUDED WITH THIS SOURCE.   *
 * PLEASE READ THESE TERMS DISTRIBUTING.                            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1998             *
 * 1998 Monty and The XIPHOPHORUS Company                           *
 * http://www.xiph.com/                                             *
 *                                                                  *
 ********************************************************************

  file: ppqmf.h
  function: polyphase pseudo-quadrature mirror filterbank
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty
  last modification date: Nov 8 1998

 ********************************************************************/

#ifndef _PPQMF_H_
#define _PPQMF_H_

typedef struct ppQMF_subbander{
  int windowsize;
  int windowmult;
  int bands;

  float *buffer;       /* [windowsize] */
  float *work;         /* [windowsize] */

} ppQMF_subbander;

extern void clear_subbander(ppQMF_subbander *p);
extern ppQMF_subbander *init_subbander(int bands, int windowmult);
extern void input_subbander(ppQMF_subbander *p,float *newvals);
extern void output_subbander(ppQMF_subbander *p,float *newvals);

#endif
